/*
 * This program mmap's an anonymous region of memory and writes known patterns
 * to it and reads it back. The idea is to fire enough of these programs to
 * causes the VM to start swapping pages.
 * 
 * ./swap [mmap_size_in_gigabytes]
 */
#include <sys/types.h>
#include <sys/mman.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>

#define	GB	(1024 * 1024 * 1024UL)

int
main(int argc, char *argv[])
{
	int i, j, k;
	int *ip, pid;
	u_long mmap_len;

	if (argc == 2)
		mmap_len = strtoul(argv[1], NULL, 0);
	else
		mmap_len = 3;
	printf("Using mmap length of %luGB\n", mmap_len);

	mmap_len *= GB;

	ip = mmap(0, mmap_len, PROT_READ|PROT_WRITE, MAP_ANON, -1, 0);
	assert(ip != MAP_FAILED);

	pid = getpid();

	j = 0;
	while (1) {
		for (i = 0; i < mmap_len / sizeof(int); i++)
			ip[i] = pid + j;

		for (k = 0; k < 3; k++) {
			for (i = 0; i < mmap_len / sizeof(int); i++) {
				if (ip[i] != pid + j) {
					printf("pid = %d, j = %d, ip[%d]= %d\n",
						pid, j, i, ip[i]);
					assert(0);
				}
			}
		}

		j++;
		printf("iteration %d\n", j);
	}
}
